Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #306 (new defect)

Opened 13 years ago

Last modified 11 years ago

madwifi-ng + chipset 5211 not setting txpower, but madwifi-old/r1417 works fine(Can't set txpower by iwconfig command)

Reported by: wroblew@poczta.fm Assigned to:
Priority: major Milestone:
Component: madwifi: other Version: trunk
Keywords: txpower Cc:
Patch is attached: 0 Pending:

Description

I have miniPCI Philips card build on 5211 Atheros chipset. Just after load module ath_pci I execute iwconfig command and it shows:

ath0      IEEE 802.11b  ESSID:""
          Mode:Master  Frequency:2.412 GHz  Access Point: 00:05:4E:42:32:A1
          Bit Rate:0 kb/s   Tx-Power:0 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

Why I have only 0 dBm at Tx-Power parameter? When I want to change it by command # iwconfig ath0 txpower 10 it show:

ath0      IEEE 802.11b  ESSID:""
          Mode:Master  Frequency:2.412 GHz  Access Point: 00:05:4E:42:32:A1
          Bit Rate:0 kb/s   Tx-Power=off   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

It return to 0dBm by execute command # iwconfig ath0 txpower auto Any idea? Maybe I did something wrong? Slackware 10.2, kernel 2.4.29, madwifi driver compiled today

Change History

01/11/06 22:33:29 changed by anonymous

did you hink about setting essid before txpower?

01/11/06 23:29:28 changed by wroblew@poczta.fm

yes, it doesn't matter if I set essid or not, but thanks

01/12/06 06:06:30 changed by mrenzmann

Is that really with madwifi-ng? What happens when you use "ifconfig ath0 up"?

01/12/06 07:06:28 changed by wroblew@poczta.fm

Yes, I download snapshot madwifi-ng-r1393-20060111. When I up ath0 interface use ifconfig command it behave equally - nothing change after "iwconfig ath0 txpower 10", Tx-Power still show off. If I use 'iwlist txpower' it shows at ath0 interface info as below:

ath0      unknown transmit-power information.

          Current Tx-Power:off

After 'iwconfig ath0 txpower auto' command 'iwlist txpower' shows:

ath0      unknown transmit-power information.

          Current Tx-Power:0 dBm        (1 mW)

Anyway thanks.

01/12/06 19:23:54 changed by wroblew@poczta.fm

Anybody know how can I solve this problem? Maybe should I deliver other data in ticket if that didn't describe the problem enough?

01/30/06 15:11:20 changed by Irapuan Pascoal

For me... the txpower only work after I realize the ifconfig UP...

02/12/06 16:55:56 changed by Mister_X

  • patch_attached changed.

You should try with the latest revision (1451). It didn't work (for me) when the txpower patch was applied but now it works fine (maybe it was a bug in HAL [HAL was updated in revision 1450]).

02/23/06 00:17:24 changed by wroblew@poczta.fm

I installed the new version of madwifi, as you suggested. It seems that something to change better - iwconfig shows the txpower 17 dBm, but I can't change it. Tx-power still always 17 dBm. Do you know why?

02/24/06 05:57:51 changed by mrenzmann

Did you try to increase or decrease the TX power?

03/02/06 10:11:39 changed by wroblew@poczta.fm

Yes, I did. If I use e.g. iwconfig ath0 txpower 10 command, it execute, don't return any errors, and iwconfig command shows always Tx-Power:17 dBm. It's better than in the previous version madwifi, because don't change txpower to "off" status. I'll update madwifi once again and check it today evening so I'll send information if something change.

03/02/06 21:49:37 changed by wroblew@poczta.fm

My card behaviour very strange. Sometimes it shows Tx-Power 0 dBm, sometimes 17 dBm, and sometimes off. But I saw very interesting thing. I can change txpower if I down interface ath0 or wifi0 ifconfig ath0 down. So, comand iwconfig ath0 txpower 10 change value Tx-Power=10 dBm, but if I up interface ath0 again, Tx-Power return to 'off'. Nothing change in power (I see power on Netstumbler program). dmesg command output:

pci_hotplug: PCI Hot Plug PCI Core version: 0.5
pciehp: PCI Express Hot Plug Controller Driver version: 0.5
hw_random: misc device register failed
ath_pci: driver unloaded
ath_rate_sample: unloaded
ath_hal: driver unloaded
ath_hal: 0.9.16.16 (AR5210, AR5211, AR5212, RF5111, RF5112, RF2413, RF5413)
ath_rate_sample: 1.2 (svn 1457)
ath_pci: 0.9.4.5 (svn 1457)
PCI: Found IRQ 15 for device 01:03.0
PCI: Sharing IRQ 15 with 00:01.0
wifi0: 11a rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi0: H/W encryption support: WEP AES
wifi0: mac 4.2 phy 3.0 5ghz radio 1.7 2ghz radio 2.3
wifi0: Use hw queue 0 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 0 for WME_AC_VI traffic
wifi0: Use hw queue 0 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5211: mem=0xfebf0000, irq=15
rix 255 (0) bad ratekbps 0 mode 1
rix 255 (0) bad ratekbps 0 mode 1
(...)

03/23/06 20:31:18 changed by pstaszewski@artcom.pl

I have the same problem. With r1482,1481,1480 and other drivers versions.

04/05/06 22:00:26 changed by dyqith

  • status changed from new to assigned.
  • owner set to dyqith.

Can you please take a look at http://madwifi.org/ticket/508

04/18/06 19:48:58 changed by dyqith

patched in r1512.

Please try the latest revision and let me know if the issues mentioned in this ticket are fixed.

05/15/06 07:45:14 changed by keith@ksmith.com

There is definately a problem here, and it is affected by time, or maybe attempts coupled with time.

iwconfig commands appear to be completely ignored sometimes. I've tried different timeouts, before during after and in-between various commands. See the comments I put in the trace below. Repeating the entire sequence will make it work. *SOMETIMES*.

Custom setup: 2.4.31 kernel Madwifi < 1 week old, and I keep updating, not seeing many changed files that would appear to be relevant.

Tested with CM6,CM9,EMP-8602,NTE-312AA (A-Only) WRAP .2C .1E w/latest firmware Soekris 4511 4521 w/latest firmware

I run into channel set problems in master mode even on the A only card setting an A channel. Wierd.


Below is a script trace (custom) card was CM-6 on this pass.
===> Means a Comment from me

. . . ===> ath_pci loaded manually, other modules auto
Module ath_rate_sample loaded, with warnings
Module ath_pci loaded, with warnings
+ '[' wifi0 = '' ']'
+ wlanmode=ap
+ wlanconfig ath0 create wlandev wifi0 wlanmode ap
ath0
+ iwconfig ath0
ath0      IEEE 802.11b  ESSID:""
          Mode:Master  Channel:0  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:50 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

===> So far so good.  This is checking for an 802.11 mode and the 
===> requested channel this is to run on.  In this case I want 
===> channel 161 and the mode is not set in the config file
+ '[' '(' 0 -eq 0 ')' -a '(' 161 -gt 11 ')' ']'
+ ap_mode=1
+ '[' '(' 1 ')' -a '(' 1 -ne 0 ')' ']'
===> This is some BS I put in the script to try 3 times to set mode
===> NOTE: I've done this before and after other parms
+ ix=4
+ '[' 4 -gt 0 ']'
===> OK attempt to set the mode to 1 (11a)
+ iwpriv ath0 mode 1
+ sleep 2
===> get_mode=`iwpriv $iface get_mode | awk -F ':' ' {print $2}'`
++ iwpriv ath0 get_mode
++ awk -F : ' {print $2}'
+ get_mode=11b
+ echo 'Got mode = 11b'
Got mode = 11b
++ expr 4 - 1
+ ix=3
+ '[' 3 -gt 0 ']'
===> OK again
+ iwpriv ath0 mode 1
+ sleep 2
++ iwpriv ath0 get_mode
++ awk -F : ' {print $2}'
+ get_mode=11b
+ echo 'Got mode = 11b'
Got mode = 11b
++ expr 3 - 1
+ ix=2
+ '[' 2 -gt 0 ']'
===> OK Try # 3
+ iwpriv ath0 mode 1
+ sleep 2
++ iwpriv ath0 get_mode
++ awk -F : ' {print $2}'
+ get_mode=11b
+ echo 'Got mode = 11b'
Got mode = 11b
++ expr 2 - 1
+ ix=1
+ '[' 1 -gt 0 ']'
===> Try # 4
+ iwpriv ath0 mode 1
+ sleep 2
++ iwpriv ath0 get_mode
++ awk -F : ' {print $2}'
+ get_mode=11b
+ echo 'Got mode = 11b'
Got mode = 11b
++ expr 1 - 1
+ ix=0
+ '[' 0 -gt 0 ']'
===> Give up, set up antenna.  This works every time no matter
===> what the values, or where it is in the script . . .
===>    [ \( "$antsel_rx" != "0" \) -o \( "$antsel_tx" != "0" \) ] && \
===>        echo "0" > /proc/sys/dev/$wifi/diversity
===>    [ "$antsel_rx" != "0" ] && \
===>        echo $antsel_rx > /proc/sys/dev/$wifi/rxantenna
===>    [ "$antsel_tx" != "0" ] && \
===>        echo $antsel_tx > /proc/sys/dev/$wifi/txantenna
+ '[' '(' 1 '!=' 0 ')' -o '(' 1 '!=' 0 ')' ']'
+ echo 0
+ '[' 1 '!=' 0 ']'
+ echo 1
+ '[' 1 '!=' 0 ']'
+ echo 1
+ '[' 300 ']'
+ athctrl -i wifi0 -d 300
Setting distance on interface wifi0 to 300 meters
+ start_wcommon
+ ifconfig ath0 up
===> ESSID setup.  This works every time, no matter where it is.
+ '[' CasaFiestaA ']'
+ iwconfig ath0 essid CasaFiestaA
+ sleep 2
===> Pointless sleep, I've taken this up to 10 seconds to no avail
===> If we are a master we can set the channel
+ '[' '(' Master '!=' Managed ')' -a '(' 161 ')' ']'
+ echo 'iwconfig ath0 channel 161'
iwconfig ath0 channel 161
+ iwconfig ath0 channel 161
+ sleep 2
===> Another pointless sleep, Note the channel. . . It is Wrong!!!
===> Channel 161 = 5.805
===> *and* no error given either. . .
+ iwconfig ath0
ath0      IEEE 802.11Ta  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:5.765 GHz  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:14 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

===> Now we try to set power, which pukes.  Now this is odd.  According to
===> the documentation setting power to 30 will always select the highest
===> available power.  This does not work on anything but the emp card.
===> The biggest number you can plug in varies by selected channel, but is
===> *always higher* than the reported number from iwconfig.  Too wierd :)
+ '[' 25 '!=' auto ']'
+ echo 'iwconfig ath0 txpower 25'
iwconfig ath0 txpower 25
+ iwconfig ath0 txpower 25
Error for wireless request "Set Tx Power" (8B26) :
    SET failed on device ath0 ; Operation not supported.
+ '[' 0 -a '(' 0 -ne 0 ')' ']'
+ '[' '' ']'
===>
===> So fuggit,  I run thru the common stuff twice for madwifi 
===> (I use hostap stuff too)
+ start_wcommon
+ ifconfig ath0 up
+ '[' CasaFiestaA ']'
+ iwconfig ath0 essid CasaFiestaA
+ sleep 2
+ '[' '(' Master '!=' Managed ')' -a '(' 161 ')' ']'
+ echo 'iwconfig ath0 channel 161'
iwconfig ath0 channel 161
+ iwconfig ath0 channel 161
+ sleep 2
+ iwconfig ath0
ath0      IEEE 802.11a  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:5.805 GHz  Access Point: 00:0B:6B:33:5A:D0
          Bit Rate:0 kb/s   Tx-Power:14 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

===> MAGIC!
===> The channel sets this time.  NOTE: LONG TIMEOUT's above do not help
===> even between commands, but now all of a sudden, re-running the ESSID
===> set, and the channel set it works, and of course the power will then
===> set below!
===> This does not *always* work! But is relatively reliable.
+ '[' 25 '!=' auto ']'
+ echo 'iwconfig ath0 txpower 25'
iwconfig ath0 txpower 25
+ iwconfig ath0 txpower 25
+ '[' 0 -a '(' 0 -ne 0 ')' ']'
+ '[' '' ']'
+ ifconfig ath0
+ '[' 10.100.128.1 ']'
+ /sbin/ifconfig ath0 10.100.128.1 netmask 255.255.255.0 broadcast 10.100.128.255
+ '[' disable = enable ']'
+ '[' '' ']'
+ exit 0


I'd be happy to test any changes thouroughly with all my various cards. I consider this a critical problem really because I cannot reliably fire up a MADWIFI based AP. I had to fork the madwifi startup severely because of 'wlanconfig', but this was a problem even with the old madwifi stuff in AP mode. I have *never* been able to get a reliable channel set, even in the 'B' or 'G' band/modes, with and without iwpriv athX mode X

In reality one should be able to simply set the channel, and go. With hostap you can set this stuff in any order. It maintains the settings internally and will reset what is neccessary at ioctl time. If time permits I might could dig into this, but I have no clue about the 'HAL' layer API.

--KS

05/15/06 07:48:57 changed by keith@ksmith.com

Note: above from source: madwifi-ng-r1546-20060511

05/15/06 08:43:23 changed by dyqith

A few things: Are you sure you're using r1546 (i.e. installed and loaded in memory) because your iwconfig shows 50 dBm txpower on startup (which really I set it to 0).

Remember nothing changes until you do "ifconfig ath0 up". "iwlist ath0 txpower" should show the max power you can set based on the channel/mode/regulatory constraints.

Can you show the above commands ? thanks.

05/16/06 09:30:20 changed by keith@ksmith.com

I am *POSITIVE* on the release. The build deletes everything and extracts from the .tar.gz. I keep replacing it with newer ones. Change to NG was to get support for the 400mW card && required script changes for wlanconfig.

I've built a simple script extracting the active code above, Lets walk this by hand . . .

===> This shuts everything off (interfaces) and removes the modules . . .
===> NOTE: This only fails on first pass after loading the modules, so we
===>       make sure the machine is like it is at bootup.
[netstation]/tmp<16>/etc/rc.d/init.d/ethx.i stop ath0
rmmod wlan_scan_ap
rmmod ath_pci
rmmod ath_rate_sample
rmmod wlan
rmmod ath_hal

===> Now let's look at a freshly created script . . .
[netstation]/tmp<17>cat madwifi-test
#!/bin/sh
modprobe ath_pci autocreate=none
wlanconfig ath0 create wlandev wifi0 wlanmode ap
iwconfig ath0
athctrl -i wifi0 -d 300
ifconfig ath0 up
iwconfig ath0
iwconfig ath0 essid CasaFiestaA
iwconfig ath0
iwconfig ath0 channel 161
iwconfig ath0
iwconfig ath0 txpower 25
iwconfig ath0

===> NOTE: load module, create ap device, Up iface, set id,
===>  then channel, then power . . .
===> Let's run it noisily and look after every step . . .
[netstation]/tmp<18>sh -x madwifi-test
+ modprobe ath_pci autocreate=none
Note: /etc/modules.conf is more recent than /lib/modules/2.4.31/modules.dep
Warning: loading /lib/modules/2.4.31/misc/ath_hal.o will taint the kernel: non-GPL license - Proprietary
  See http://www.tux.org/lkml/#export-tainted for information about tainted modules
Module ath_hal loaded, with warnings
Module wlan loaded, with warnings
Module ath_rate_sample loaded, with warnings
Module ath_pci loaded, with warnings
+ wlanconfig ath0 create wlandev wifi0 wlanmode ap
ath0
===> I dunno what to tell you,. At this point there is no reported channel and a
===> reported TX power of 50.  Total nonsense in this case as this test is now
===> running on a CM6, max power = 18db/11b by spec
+ iwconfig ath0
ath0      IEEE 802.11b  ESSID:""
          Mode:Master  Channel:0  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:50 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

+ athctrl -i wifi0 -d 300
Setting distance on interface wifi0 to 300 meters
===> Turning on the interface as an AP now gives us some sane stuff.
===> 11g/18dBm AP on channel 1, sans ESSID
+ ifconfig ath0 up
+ iwconfig ath0
ath0      IEEE 802.11g  ESSID:""
          Mode:Master  Frequency:2.412 GHz  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:18 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

===> Now lets change the ESSID to a word, and it's happy . . .
+ iwconfig ath0 essid CasaFiestaA
+ iwconfig ath0
ath0      IEEE 802.11g  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:2.412 GHz  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:18 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

===> Now change the channel to 161 (11a)
===> FAILS!
+ iwconfig ath0 channel 161
+ iwconfig ath0
ath0      IEEE 802.11g  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:2.412 GHz  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:18 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

===> And of course the power setting barfs too.
+ iwconfig ath0 txpower 25
Error for wireless request "Set Tx Power" (8B26) :
    SET failed on device ath0 ; Operation not supported.
+ iwconfig ath0
ath0      IEEE 802.11g  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:2.412 GHz  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:18 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

There it is 6 commands in a row, fails every time. Couple of other config/hw items:

[netstation]/tmp<19>cat /proc/cpuinfo
processor       : 0
vendor_id       : Geode by NSC
cpu family      : 5
model           : 4
model name      : Geode(TM) Integrated Processor by National Semi
stepping        : 0
cpu MHz         : 266.637
fdiv_bug        : no
hlt_bug         : no
f00f_bug        : no
coma_bug        : no
fpu             : yes
fpu_exception   : yes
cpuid level     : 2
wp              : yes
flags           : fpu tsc msr cx8 cmov mmx
bogomips        : 532.48

[netstation]/tmp<20>free
             total       used       free     shared    buffers     cached
Mem:        127152      44368      82784          0       2252      34708
-/+ buffers/cache:       7408     119744

[netstation]/tmp<21>df
Filesystem           1K-blocks      Used Available Use% Mounted on
/dev/ram0                20821     14895      4851  76% /
tmpfs                    63488       108     63380   1% /var
/dev/hda1                20328      7857     11422  41% /cf
/dev/loop0               10816     10816         0 100% /disk

[netstation]/tmp<22>ifconfig
ath0      Link encap:Ethernet  HWaddr 00:0B:6B:33:5A:D0
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0
          TX packets:0 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:0 (0.0 b)  TX bytes:0 (0.0 b)

eth0      Link encap:Ethernet  HWaddr 00:0D:B9:01:FF:94
          inet addr:192.168.64.117  Bcast:192.168.64.127  Mask:255.255.255.128
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:724 errors:0 dropped:0 overruns:0 frame:0
          TX packets:266 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:57943 (56.5 Kb)  TX bytes:38267 (37.3 Kb)
          Interrupt:10 Base address:0x4000

eth1      Link encap:Ethernet  HWaddr 00:0D:B9:01:FF:95
          inet addr:10.0.0.1  Bcast:10.0.0.255  Mask:255.255.255.0
          UP BROADCAST MULTICAST  MTU:1500  Metric:1
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0
          TX packets:0 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:0 (0.0 b)  TX bytes:0 (0.0 b)
          Interrupt:11 Base address:0x6000

lo        Link encap:Local Loopback
          inet addr:127.0.0.1  Mask:255.0.0.0
          UP LOOPBACK RUNNING  MTU:16436  Metric:1
          RX packets:0 errors:0 dropped:0 overruns:0 frame:0
          TX packets:0 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:0 (0.0 b)  TX bytes:0 (0.0 b)

wifi0     Link encap:UNSPEC  HWaddr 00-0B-6B-33-5A-D0-00-00-00-00-00-00-00-00-00-00
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:11 errors:0 dropped:0 overruns:0 frame:911839
          TX packets:57 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:199
          RX bytes:1164 (1.1 Kb)  TX bytes:2714 (2.6 Kb)
          Interrupt:9 Memory:c888f000-c889f000

U tell me. I'm at a loss

05/16/06 09:35:56 changed by dyqith

hmm... 1) Please do this after your modprobe ath_pci;

dmesg | tail -n 50 (so i can see what the revision number on it is)

2) before you run ifconfig ath0 up, please run "iwpriv ath0 mode 11a"

3) iwconfig ath0 txpower 25 probably won't work, check "iwlist ath0 txpower" to see what's the highest rating (after you set your channel)

05/16/06 18:06:06 changed by anonymous

tail -n 50 huh . . .

START UNRELATED RANT . . . The audacity of the GNU people to trash the syntax of head/tail is beyond the pale. After examining a few zillion scripts that run the syntax of the last *THIRTY FREAKING YEARS*, I just wrote my own compatable one and tossed theirs in the toilet. Prime example of taking something dirt simple . . . It make perfect sense to me to break millions of scripts that have been running for 20+ years for no reason. END RANT

FYI. On this card (CM6) this will get us in the 'A' band, but the FREQ set still fails leaving us at 5.18. On the EMP-86xx (I think it was. 5212 chip) it ignores it. On the NTE (A Only) this will accompish nothing.

[netstation]/tmp<74>!cat
cat madwifi-test
#!/bin/sh
modprobe ath_pci autocreate=none
dmesg | tail -50
wlanconfig ath0 create wlandev wifi0 wlanmode ap
iwconfig ath0
athctrl -i wifi0 -d 300
iwpriv ath0 mode 11a
ifconfig ath0 up
iwconfig ath0 essid CasaFiestaA
iwconfig ath0 channel 161
iwconfig ath0
iwconfig ath0 txpower 25
iwconfig ath0
[netstation]/tmp<75>!.
./madwifi-test
Note: /etc/modules.conf is more recent than /lib/modules/2.4.31/modules.dep
Warning: loading /lib/modules/2.4.31/misc/ath_hal.o will taint the kernel: non-GPL license - Proprietary
  See http://www.tux.org/lkml/#export-tainted for information about tainted modules
Module ath_hal loaded, with warnings
Module wlan loaded, with warnings
Module ath_rate_sample loaded, with warnings
Module ath_pci loaded, with warnings
wifi0: mac 5.6 phy 4.1 5ghz radio 1.7 2ghz radio 2.3
wifi0: Use hw queue 1 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 2 for WME_AC_VI traffic
wifi0: Use hw queue 3 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5212: mem=0x80080000, irq=9
ath_pci: driver unloaded
ath_rate_sample: unloaded
wlan: driver unloaded
ath_hal: driver unloaded
ath_hal: 0.9.16.16 (AR5210, AR5211, AR5212, RF5111, RF5112, RF2413, RF5413)
wlan: 0.8.4.2 (svn 1500)
ath_rate_sample: 1.2 (svn 1500)
ath_pci: 0.9.4.5 (svn 1500)
wifi0: 11a rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi0: 11g rates: 1Mbps 2Mbps 5.5Mbps 11Mbps 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: turboA rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: H/W encryption support: WEP AES AES_CCM TKIP
wifi0: mac 5.6 phy 4.1 5ghz radio 1.7 2ghz radio 2.3
wifi0: Use hw queue 1 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 2 for WME_AC_VI traffic
wifi0: Use hw queue 3 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5212: mem=0x80080000, irq=9
ath_pci: driver unloaded
ath_rate_sample: unloaded
wlan: driver unloaded
ath_hal: driver unloaded
ath_hal: 0.9.16.16 (AR5210, AR5211, AR5212, RF5111, RF5112, RF2413, RF5413)
wlan: 0.8.4.2 (svn 1500)
ath_rate_sample: 1.2 (svn 1500)
ath_pci: 0.9.4.5 (svn 1500)
wifi0: 11a rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi0: 11g rates: 1Mbps 2Mbps 5.5Mbps 11Mbps 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: turboA rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: H/W encryption support: WEP AES AES_CCM TKIP
wifi0: mac 5.6 phy 4.1 5ghz radio 1.7 2ghz radio 2.3
wifi0: Use hw queue 1 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 2 for WME_AC_VI traffic
wifi0: Use hw queue 3 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5212: mem=0x80080000, irq=9
ath0
ath0      IEEE 802.11b  ESSID:""
          Mode:Master  Channel:0  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:50 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

Setting distance on interface wifi0 to 300 meters
ath0      IEEE 802.11a  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:5.18 GHz  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:14 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

Error for wireless request "Set Tx Power" (8B26) :
    SET failed on device ath0 ; Operation not supported.
ath0      IEEE 802.11a  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:5.18 GHz  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:14 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

05/16/06 18:27:20 changed by keith@ksmith.com

Got a workaround. I knew this had something to do with time. Something is not ready, and is not reporting a problem. It's odd, that it takes the ESSID without the wait, but the channel request will not take without it, and subseqently the txpower fails. If you wait 15 seconds (gosh that is a LONG time) life is good. I stopwatched myself typing the stuff in. Takes longer than I thought to type the lines by hand :).

~ 15 seconds would seem to be magic on this one, and it must be after the ifconfig up. Running it after the module has no effect. I wonder if there is a CPU speed thing happening here, ie shorter on a faster CPU or something. I started with 30, and worked my way down. My original *long* sleeps were 10 seconds, evidently this was not long enough *every time*. Sometimes it worked, sometimes it didn't. Perhaps something in the init routine on "up".

Simply taking the interface down and then running the ifconfig up and iwconfig commands does not require the sleep in order to work, so it's first time initialization.

Note: Shortened the dmesg tail, no need to see 3 instances of load/unload. No other activity on this box to glob things up.

[netstation]/tmp<100>cat madwifi-test
#!/bin/sh
modprobe ath_pci autocreate=none
dmesg | tail -20
wlanconfig ath0 create wlandev wifi0 wlanmode ap
iwconfig ath0
athctrl -i wifi0 -d 300
iwpriv ath0 mode 11a
ifconfig ath0 up
sleep 15
iwconfig ath0 essid CasaFiestaA
iwconfig ath0 channel 161
iwconfig ath0
iwconfig ath0 txpower 25
iwconfig ath0

[netstation]/tmp<101>sh -x ./madwifi-test
+ modprobe ath_pci autocreate=none
Note: /etc/modules.conf is more recent than /lib/modules/2.4.31/modules.dep
Warning: loading /lib/modules/2.4.31/misc/ath_hal.o will taint the kernel: non-GPL license - Proprietary
  See http://www.tux.org/lkml/#export-tainted for information about tainted modules
Module ath_hal loaded, with warnings
Module wlan loaded, with warnings
Module ath_rate_sample loaded, with warnings
Module ath_pci loaded, with warnings
+ dmesg
+ tail -20
ath_rate_sample: unloaded
wlan: driver unloaded
ath_hal: driver unloaded
ath_hal: 0.9.16.16 (AR5210, AR5211, AR5212, RF5111, RF5112, RF2413, RF5413)
wlan: 0.8.4.2 (svn 1500)
ath_rate_sample: 1.2 (svn 1500)
ath_pci: 0.9.4.5 (svn 1500)
wifi0: 11a rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi0: 11g rates: 1Mbps 2Mbps 5.5Mbps 11Mbps 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: turboA rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi0: H/W encryption support: WEP AES AES_CCM TKIP
wifi0: mac 5.6 phy 4.1 5ghz radio 1.7 2ghz radio 2.3
wifi0: Use hw queue 1 for WME_AC_BE traffic
wifi0: Use hw queue 0 for WME_AC_BK traffic
wifi0: Use hw queue 2 for WME_AC_VI traffic
wifi0: Use hw queue 3 for WME_AC_VO traffic
wifi0: Use hw queue 8 for CAB traffic
wifi0: Use hw queue 9 for beacons
wifi0: Atheros 5212: mem=0x80080000, irq=9
+ wlanconfig ath0 create wlandev wifi0 wlanmode ap
ath0
+ iwconfig ath0
ath0      IEEE 802.11b  ESSID:""
          Mode:Master  Channel:0  Access Point: 00:00:00:00:00:00
          Bit Rate:0 kb/s   Tx-Power:50 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

+ athctrl -i wifi0 -d 300
Setting distance on interface wifi0 to 300 meters
+ iwpriv ath0 mode 11a
+ ifconfig ath0 up
+ sleep 15
+ iwconfig ath0 essid CasaFiestaA
+ iwconfig ath0 channel 161
+ iwconfig ath0
ath0      IEEE 802.11a  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:5.805 GHz  Access Point: 00:0B:6B:33:5A:D0
          Bit Rate:0 kb/s   Tx-Power:14 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

+ iwconfig ath0 txpower 25
+ iwconfig ath0
ath0      IEEE 802.11a  ESSID:"CasaFiestaA"
          Mode:Master  Frequency:5.805 GHz  Access Point: 00:0B:6B:33:5A:D0
          Bit Rate:0 kb/s   Tx-Power=17 dBm   Sensitivity=0/3
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=0/94  Signal level=-95 dBm  Noise level=-95 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0


05/21/06 14:52:52 changed by konrad@ffs.pl

r1560 is not working properly with 5211 chips (tested on two m-pci cards from Alps)

symptoms are 0dBm / off on txpow in whatever mode (ap/sta/wds..)

also tried with older version i was using with 5212 chipsets beafore (not without problems there) and it seemed to work only in sta mode, in ap/wds was 0dBm

old drivers (old-r1417) works fine

i tried waiting those 30s (even few mins) beafore setting anything up, it didnt worked

05/21/06 17:25:57 changed by dyqith

And tried to bring the interface up and checked iwconfig for the txpower ?

When the interface starts (in down mode), the txpower should be 0, when it comes up, it should be whatever max value your card allows.

Does that work ?

05/22/06 21:31:34 changed by konrad@ffs.pl

no it doesnt, it says 0dBm beafore and after, with or without 30 sec wait (even few minutes wait time)

if you try to change txpower you get "off" instead (after ifconfig up)

setting anything after getting it up with iwconfig doesnt change anything (except that txpower -> off thing)

05/26/06 08:10:14 changed by dyqith

  • summary changed from Can't set txpower by iwconfig command to madwifi-ng + chipset 5211 not setting txpower, but madwifi-old/r1417 works fine(Can't set txpower by iwconfig command).

09/27/06 15:06:43 changed by vinaysagar@gmail.com

Hi All,

I am using a AP30 SoC board (Ar5312A chipset). In b/g mode the signal power as seen by the sniffer is -30dbm. But in b mode the power drops to -50dbm(very low).

Initially iwconfig txpower shows txpower of 5 dbm and if i set the tx power it doesnt seem to work.

iwconfig ath0 ath0 IEEE 802.11b ESSID:"11btxpower"

Mode:Master Frequency:2.447GHz Access Point: 00:0C:E6:B6:02:12 Bit Rate:0kb/s Tx-Power=5 dBm Sensitivity=0/3 Retry:off RTS thr:off Fragment thr:off Encryption key:off Power Management:off Link Quality:0/94 Signal level:-95 dBm Noise level:-95 dBm Rx invalid nwid:0 Rx invalid crypt:0 Rx invalid frag:0 Tx excessive retries:0 Invalid misc:0 Missed beacon:0

iwconfig ath0 txpow 25

iwconfig ath0 ath0 IEEE 802.11b ESSID:"11btxpower"

Mode:Master Frequency:2.447GHz Access Point: 00:0C:E6:B6:02:12 Bit Rate:0kb/s Tx-Power=25 dBm Sensitivity=0/3 Retry:off RTS thr:off Fragment thr:off Encryption key:off Power Management:off Link Quality:43/94 Signal level:-52 dBm Noise level:-95 dBm Rx invalid nwid:0 Rx invalid crypt:0 Rx invalid frag:0 Tx excessive retries:0 Invalid misc:0 Missed beacon:0

But i see no change in the signal power.

Thanks and Regards, vinay

10/28/06 00:59:51 changed by jimis

I verify this bug. I own two identical devices with 5211 chipset. I get the same behaviour. In master mode the txpower is unconfigurable, however in station mode /sometimes/ is is configurable but automatically reverts to "off" after some minutes. Tampering with countrycode and regdomain doesn't seem to help.

lspci -v:

03:08.0 Ethernet controller: Atheros Communications, Inc. AR5211 802.11ab NIC (rev 01)
        Subsystem: Askey Computer Corp. Unknown device 7005
        Flags: bus master, medium devsel, latency 168, IRQ 5
        Memory at ee810000 (32-bit, non-prefetchable) [size=64K]
        Capabilities: [44] Power Management version 2

dmesg:

wifi1: 11a rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi1: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
wifi1: turboA rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
wifi1: H/W encryption support: WEP AES
wifi1: mac 4.2 phy 3.0 5ghz radio 1.7 2ghz radio 2.3
wifi1: Use hw queue 0 for WME_AC_BE traffic
wifi1: Use hw queue 0 for WME_AC_BK traffic
wifi1: Use hw queue 0 for WME_AC_VI traffic
wifi1: Use hw queue 0 for WME_AC_VO traffic
wifi1: Use hw queue 8 for CAB traffic
wifi1: Use hw queue 9 for beacons
wifi1: Atheros 5211: mem=0xee810000, irq=10

iwconfig ath1:

ath1      IEEE 802.11a  ESSID:"test"  
          Mode:Master  Frequency:5.32 GHz  Access Point: xx:xx:xx:xx:xx:xx   
          Bit Rate:0 kb/s   Tx-Power:0 dBm   Sensitivity=0/3  
          Retry:off   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=25/94  Signal level=-69 dBm  Noise level=-94 dBm
          Rx invalid nwid:35  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:0  Invalid misc:0   Missed beacon:0

iwlist ath1 txpower:

ath1      unknown transmit-power information.

          Current Tx-Power:0 dBm        (1 mW)

iwconfig ath1 txpower 10:

Error for wireless request "Set Tx Power" (8B26) :
    SET failed on device ath1 ; Invalid argument.

11/29/06 15:22:11 changed by jimis

I still got the problem, any comment from the developers concerning support for 5211 chipset?

11/30/06 07:03:53 changed by mrenzmann

5211 should be working without problems in theory. I have only one 5211 card available in the office, and that is currently blocked by someone else, so it might take some time until I can give it a test.

12/01/06 23:35:00 changed by jimis

OK, thanks, please tell me if there is anything I can do to help.

(follow-up: ↓ 38 ) 01/16/07 10:08:56 changed by vinaysagar@gmail.com

Hi All,

I think there is a bug in ath_update_txpow() function. The way in which the maximum txpower of chip is calculated is wrong.

/********* original code *******************/

u_int32_t maxtxpowlimit = 9999; u_int32_t clamped_txpow = 0;

/*

  • Find the maxtxpow of the card and regulatory constraints */

(void)ath_hal_getmaxtxpow(ah, &txpowlimit); ath_hal_settxpowlimit(ah, maxtxpowlimit); (void)ath_hal_getmaxtxpow(ah, &maxtxpowlimit); ic->ic_txpowlimit = maxtxpowlimit; ath_hal_settxpowlimit(ah, txpowlimit);

/********************************************/

In the above lines of code, a very high value of 9999 is set to txpowlimit using ath_hal_settxpowlimit()function. The logic is that the hal will put in a sane value instead of 9999. but while reading back the values --> ath_hal_getmaxtxpow() is used.

For .11b mode the hal is returning a very low value for ath_hal_getmaxtxpow().

Replacing ath_hal_getmaxtxpow() with ath_hal_gettxpowlimit() is working fine for me with ar5312A soc.

Regards, Vinay

01/20/07 22:52:18 changed by jimis

Thank you vinaysagar! This seems to resolve half the problem on 5211 chipset, 802.11a.

In station mode txpower is at last configurable!

In master mode however, while txpower seems to change value in iwconfig, in reality nothing changes (as measured from a distant client).

Anyway, thanks again for the workaround, at least now I'm able to use my cards in managed mode. :-)

01/23/07 22:00:30 changed by dyqith

Updated trunk with the change suggested by vinaysagar.

committed to revision 1995

02/20/07 16:49:44 changed by Ronald.intVelt@tno.nl

Could it be that the change made in r1995 as per Vinaysagar's suggestion is causing insane max Tx power values (31 dBm) to reported by iwconfig and iwlist ath<x> txpower? (At least in Ad Hoc mode, haven't tried other modes).

02/20/07 16:58:01 changed by dyqith

Yes, the change in r1995 is making the driver report bad values for the tx power.

03/03/07 07:26:04 changed by proski

I've reverted r1995 in preparation for 0.9.3 release. Regressions is the last thing we want in the release. The right fix for the "off" reading should be to never report measured or otherwise variable data with the "fixed" flag. The intermittent 0 txpower reporting by AR5211 is probably a bug of the chipset that cannot be worked around easily.

07/24/07 20:55:48 changed by dyqith

  • status changed from assigned to new.
  • owner deleted.

(in reply to: ↑ 31 ) 09/05/07 08:54:45 changed by hbhs@rediffmail.com

Dear Vinay,

I too felt there is bug in ath_update_txpow() function. Replacing ath_hal_getmaxtxpow() with ath_hal_gettxpowlimit() is working fine But by default it set to 31dBM which is very dangerous. so want set default value to 23dBm. Can you please let me know where i can set default value to 23dBm.

looking for your reply

regards Hareesh

Replying to vinaysagar@gmail.com:

Hi All, I think there is a bug in ath_update_txpow() function. The way in which the maximum txpower of chip is calculated is wrong. /********* original code *******************/ u_int32_t maxtxpowlimit = 9999; u_int32_t clamped_txpow = 0; /* * Find the maxtxpow of the card and regulatory constraints */ (void)ath_hal_getmaxtxpow(ah, &txpowlimit); ath_hal_settxpowlimit(ah, maxtxpowlimit); (void)ath_hal_getmaxtxpow(ah, &maxtxpowlimit); ic->ic_txpowlimit = maxtxpowlimit; ath_hal_settxpowlimit(ah, txpowlimit); /********************************************/ In the above lines of code, a very high value of 9999 is set to txpowlimit using ath_hal_settxpowlimit()function. The logic is that the hal will put in a sane value instead of 9999. but while reading back the values --> ath_hal_getmaxtxpow() is used. For .11b mode the hal is returning a very low value for ath_hal_getmaxtxpow(). Replacing ath_hal_getmaxtxpow() with ath_hal_gettxpowlimit() is working fine for me with ar5312A soc. Regards, Vinay

01/23/08 00:36:25 changed by tybalt

Using latest svn 3233 drivers and AR5211 under Ubuntu kernel 2.6.20-15-generic. This tx power issue still seems to be present. Also, for what it's worth I have never gotten packet injection to work properly with this chipset. With latest aircrack-ng suite svn (1.0-dev) aireplay-ng can successfully fake-auth, de-auth in monitor mode but, arp-replay, frag and chopchop all fail.